function b = beatSpectrum(V)
% Reference: Zafar Rafii and Bryan Pardo, "REpeating Pattern Extranction
% Technique (REPET): A Simple Method for Music/Voice Separation, IEEE, 2013
% BEATSPECTRUM Summary of this function goes here
% INPUT
% V: mixture spectrogram
VSquare = mean(V .^ 2, 3);
[N, m] = size(VSquare);
B = zeros(N, m);                         % Auto-Correlation
for i = 1 : N
    for j = 1 : m
        sum = 0;
        for k = 1 : m - j + 1
            sum = sum + VSquare(i, k) * VSquare(i, k + j - 1);
        end
        B(i, j) = 1 / (m - j + 1) * sum;
    end
end
b = mean(B);
b = b';
for p = 1 : j
    b(p) = b(p) / b(1);                  % Nomalization
end
figure, plot(b);                         % Plot the beat spectrum
end

