function x = istft(X, window, step)
% Reference: Zafar Rafii and Bryan Pardo, "REpeating Pattern Extranction
% Technique (REPET): A Simple Method for Music/Voice Separation, IEEE, 2013
% ISTFT Summary of this function goes here
% INPUT: 
% X: signal
% window: analysis window
% step: analysis step
[N, m] = size(X);                               % Number of frequency bins and time frames
l = (m - 1) * step + N;                         % Length with zero-padding
x = zeros(l, 1);
for j = 1 : m                                   % Loop over the frames
    x((1 : N) + step * (j - 1)) = x((1 : N) + step * (j - 1)) + real(ifft(X(:, j)));   % ifft
end
x(l - (N - step) + 1 : l) = [];                 % Remove zero-padding at the beginning
x(1 : N - step) = [];                           % Remove zero-padding at the end
x = x / sum(window(1 : step : N));              % Normalization
end

