function M = mask(V, p)
% Reference: Zafar Rafii and Bryan Pardo, "REpeating Pattern Extranction
% Technique (REPET): A Simple Method for Music/Voice Separation, IEEE, 2013
% MASK Summary of this function goes here
% INPUT:
% V: mixture spectrogram
% p: repeating period
[N, m] = size(V);
r = ceil(m / p);                % Number of repeating segments
S = [V, nan(N, r * p - m)];     % Padding
Temp = [];
for i = 1 : N
    for j = 1 : p
        sum = [];
        for k = 0 : r - 2
            sum(k + 1) = S(i, k * p + j);
        end
        Temp(i, j) = median(sum);
    end
end
S = repmat(Temp, [1, r]);       % Get repeating segment S
S = S(:, 1 : m);                % Make S have size [N, m]
W = min(V, S);
M = (W + eps) ./ (V + eps);     % Mask
end

