function X = stft(x, window, step)
% Reference: Zafar Rafii and Bryan Pardo, "REpeating Pattern Extranction
% Technique (REPET): A Simple Method for Music/Voice Separation, IEEE, 2013
% Short-Time Fourier Transform
% INPUT: 
% x: signal
% window: analysis window
% step: analysis step
t = length(x);                                          % Number of samples
N = length(window);                                     % Length of analysis window
m = ceil((N - step + t) / step);                        % Number of frames
x = [zeros(N - step, 1) ; x ; zeros(m * step - t, 1)];  % Zero-padding
X = zeros(N, m);
for j = 1 : m
    X(:, j) = fft(x((1 : N) + step * (j - 1)) .* window);
end

